require 'singleton'

module RailsIdle
  module Collector
    class Base
      include Singleton
      
      def collect
        raise NotImplementedError
      end
      
      def subscribe
        raise NotImplementedError
      end
      
      def push(item, execution_time = 1)
        storage.add(item, execution_time)
      end
      
      def storage
        @starage ||= RailsIdle::Storage::RailsCache.new
      end
      
      protected
      
      def collector_key
        self.class.to_s.demodulize.downcase.to_sym
      end
      
      private
      
      def _collect(path)
        storage.reset(path) if RailsIdle.reset?
        storage.add(path)
      end
      
    end
  end
end