module RailsIdle
  class << self
    def init!
      collect
      subscribe
    end
  
    private
    
    def _collectors
      Hash[*(RailsIdle::Collector.list.map{|c| [c, RailsIdle::Collector.instance(c)]}.flatten)]
    end
  
    def collect
      _collectors.select{|k, _| options[:collectors].include? k}.each_value(&:collect)
    end
    
    def subscribe
      _collectors.select{|k, _| options[:collectors].include? k}.each_value(&:subscribe)
    end
  end
end