module RailsIdle
  module Storage
    class Base
      
      def add(path, execution_time = nil)
        add_to_list path
      end
      
      def get(path, key)
        raise NotImplementedError
      end
      
      def reset(path)
        raise NotImplementedError
      end
      
      def objects_list
        @objects_list ||= empty_list
      end
    
      private
      
      def empty_list
        []
      end
      
      def add_to_list(path)
        objects_list << path
      end

    end
  end
end