module RailsIdle
  class TreeBuilder
    def initialize(collector)
      @storage = collector.storage
    end
    
    def tree
      @tree ||= build_tree
    end
    
    private
    
    def build_tree
      root = {}
      @storage.objects_list.each do |path|
        items = parse_path(path)
        tree = root
        items.each do |item|
          tree[item] = {} unless tree[item]
          tree = tree[item]
        end
        tree[RailsIdle::Storage::COUNTER_KEY]   = @storage.get(path, RailsIdle::Storage::COUNTER_KEY)
        tree[RailsIdle::Storage::EXECUTION_KEY] = @storage.get(path, RailsIdle::Storage::EXECUTION_KEY)
      end
      root
    end
    
    def parse_path(path)
      path.split(/,|\/|::/)
    end
    
  end
end