require 'haml'
require 'sinatra/base'
require 'rails-idle/web_helpers'

module RailsIdle
  class Web < Sinatra::Base
    
    set :root, File.expand_path(File.dirname(__FILE__) + "/../../web")
    set :public_folder, Proc.new { "#{root}/assets" }
    set :views, Proc.new { "#{root}/views" }
    
    helpers WebHelpers
    
    get '/' do
      RailsIdle.options[:collectors].each do |key|
        collector = RailsIdle::Collector.instance(key)
        @report = RailsIdle::Report.new(collector).prepare
      end
      haml :dashboard
    end
    
  end
end